#pragma once
#include <QDialog>
#include "ui_output_statistic.h"
#include <vector>
#include <qdir.h>
#include <iostream>
#include <SyncQueue.h>
#include <qthread.h>
#include "basecamera.h"
#include "tinyxml2.h"
#include "common.h"
#include "cigarette.h"

#define EXPORTDATA_FILE    "camera%1_data_info.xml"

using namespace tinyxml2;

class _XMLExportDataInfo {
public:
	// ܵͳ
	int TotalCheckNum;	// ܼ
	int TotalKickNum;	// ޳
	double PassRate;	// ϸ
	double KickRate;	// ޳
	// 
	long long cameraTotal;
	int cameraId;
	int okNum;	// ok
	int ngNum;	// ng
	int kickNum;	// ʵ޳ͨ޳ʱΪ޳
	string AcquisitionSpeed;	// ɼٶ
	int jdNum[20];	// ʶ
	string DetectSpeed;	// ٶ

	_XMLExportDataInfo() {
		// ܵͳ
		TotalCheckNum = 0;	// ܼ
		TotalKickNum = 0;	// ޳
		PassRate = 0.0;	// ϸ
		KickRate = 0.0;	// ޳
		// 
		cameraId = -1;
		okNum = 0;	// ok
		ngNum = 0;	// ng
		kickNum = 0;	// ʵ޳ͨ޳ʱΪ޳
		AcquisitionSpeed = "0ms";	// ɼٶ
		for (int i = 0; i < 20; i++)	jdNum[i] = 0;	// ʶ
		DetectSpeed = "0ms";	// ٶ
	}
};

class _ExportDataInfo
{
	struct JdPoint //
	{
		string x;
		string y;
	};

public:
	int cameraId;
	int shotCounts;
	int jd[20];
	string timeCost;
	float jdInterval;
	bool isNg;
	bool isJdExist[20];
	long long cameraTotal;
	std::vector<JdPoint> jdPointsLocation;
	float jdSize[20];

	bool getAverageData(map<string, float>& averageData, int index);

	string getPoint(int index) {
		string point = "(";
		point += jdPointsLocation.at(index).x + ',' + jdPointsLocation.at(index).y + ')';
		return point;
	}

	_ExportDataInfo()
	{
		cameraId = -1;
		jdInterval = 0.0;
		isNg = false;
		for (int i = 0; i < 20; i++)isJdExist[i] = false;
		for (int i = 0; i < 20; i++)jd[i] = 0;
		timeCost = "0ms";
		for (int i = 0; i < 20; i++)jdSize[i] = 0.0;
		shotCounts = 0;
	}
};

extern SyncQueue<_ExportDataInfo>* export_Data_Info_queue;

class ExportDataThread : public QThread
{
	Q_OBJECT
signals:


public:
	ExportDataThread(QObject* parent = 0);
	~ExportDataThread()
	{
		stop();
		//export_Data_Info_queue->put(data);
		quit();
		wait();
	}

	void init();
	void start_work();
	void stop();
	int insertXMLNode(const char* xmlPath, _ExportDataInfo& data);
	int insertXMLNode(const char* xmlPath, _XMLExportDataInfo& data);
protected:
	void run();
	void check_save_dir(std::string dir_path);
public:
	bool b_quit;
	std::vector<std::string> vec_save_dirs;
	tinyxml2::XMLDocument *pDocument[NumberOfSupportedCameras];
};
