#include "output_statistic.h"
#include "QtCore\qfile.h"
#include "QtCore\qtextstream.h"
#include "exportData.h"
#include <map>

extern ConfPath g_conf_path;

#define output_init(a, b)\
textBrowser_mat[a] = ui.textBrowser_##b;

output_statistic::output_statistic(QDialog *parent)
	: QDialog(parent)
{
	ui.setupUi(this);
	this->setWindowFlags(windowFlags()&~Qt::WindowContextHelpButtonHint);

#if defined(NumberOfSupportedCameras) && (NumberOfSupportedCameras > 0)
	output_init(0, 1);
#endif
#if defined(NumberOfSupportedCameras) && (NumberOfSupportedCameras > 1)
	output_init(1, 2);
#endif
#if defined(NumberOfSupportedCameras) && (NumberOfSupportedCameras > 2)
	output_init(2, 3);
#endif
#if defined(NumberOfSupportedCameras) && (NumberOfSupportedCameras > 3)
	output_init(3, 4);
#endif
#if defined(NumberOfSupportedCameras) && (NumberOfSupportedCameras > 4)
	output_init(4, 5);
#endif
#if defined(NumberOfSupportedCameras) && (NumberOfSupportedCameras > 5)
	output_init(5, 6);
#endif
#if defined(NumberOfSupportedCameras) && (NumberOfSupportedCameras > 6)
	output_init(6, 7);
#endif
#if defined(NumberOfSupportedCameras) && (NumberOfSupportedCameras > 7)
	output_init(7, 8);
#endif
}

output_statistic::~output_statistic()
{
}

void output_statistic::recMsgFromDialogSetup()
{
#ifdef __ExportData
	_ExportDataInfo data;
	map<string, float> averageData[NumberOfSupportedCameras];

	ui.tabWidget->setTabVisible(1, false);
	ui.tabWidget->setTabVisible(2, false);
	ui.tabWidget->setTabVisible(3, false);
	ui.tabWidget->setTabVisible(4, false);
	ui.tabWidget->setTabVisible(5, false);
	ui.tabWidget->setTabVisible(6, false);
	ui.tabWidget->setTabVisible(7, false);
	ui.tabWidget->setTabText(0, "Statistical data");


	for (int index = 0; index < NumberOfSupportedCameras; index++) {
		data.getAverageData(averageData[index], index);
		QString text;
		text.append(" CameraId: ");
		text.append(std::to_string((int)averageData[index]["CameraId"]).c_str());
		text.append("\n IsNG: ");
		text.append(std::to_string((int)averageData[index]["IsNG"]).c_str());
		text.append("\n IsJdExist: ");
		text.append(std::to_string((int)averageData[index]["IsJdExist"]).c_str());
		text.append("\n TimeCost: ");
		text.append(std::to_string(averageData[index]["TimeCost"]).c_str());
		text.append("\n*************************************************\n");
		ui.textBrowser_1->insertPlainText(text);
	}
	
#else
	QString file_path, file_name;
	QFile file;
	for (int i = 0; i < NumberOfSupportedCameras; i++) {
		file_name = QString(STATISTIC_FILE).arg(i);
		file_path = g_conf_path.config_path + "/" + file_name;
		file.setFileName(file_path);
		if (file.open(QIODevice::ReadOnly | QIODevice::Text))
		{
			QTextStream in(&file);
			//in.setCodec("UTF-8");
			textBrowser_mat[i]->setText(in.readAll());
		}
		else {
			std::cout << "can not open statistic file" << std::endl;
		}
		file.close();
		this->show();
	}
#endif
	//this->show();
}